/* Sketch a corredo delle risorse online del libro di testo
   Onelio Bertazioli
   Telecomunicazioni - Seconda edizione
   Zanichelli*/

// misura di temperatura con Arduino MKR1300 LoRaWAN e sensore LM35
//invio dei dati al network server loriot.io tramite il gateway Rasberry Pi

//----------------------------------------
#define pin_input A2  //denominiamo pin_input il pin A2 (opzionale)
int val_conv=0; //numero restituito dal convertitore A/D 
float temp; //temperatura
//---------------------------------------

#include <MKRWAN.h>
//libreria da includere che gestisce la comunicazione via LoRaWAN per Arduino MKR1300

LoRaModem modem;

//-------------------------------------------------------------------------------
//inserire i propri devAddr, nwkSKey, appSKey, fatti generare dal network server eu1.loriot.io
char * devAddr =  "ilvostro_devAddr";
char * nwkSKey = "la_vostra_nwkSKey";
char * appSKey = "la_vostra_appSKey";
//il devAddr e le chiavi sono ottenuti dal network server eui1.loriot.io al momento dell'attivazione nella modalità ABP (Activation By Personalization)
//-------------------------------------------------------------------------------

char * tempascii;
//--------------------------------------------------------------------------------------
void setup() {
   modem.begin(EU868);
   delay(1000);     
   modem.dataRate(0);   // setta il data rate DR0 (250 bit/s) che consente di operare alla massima distanza dal gateway
   delay(1000);  
  Serial.begin(9600);
  while (!Serial);
  // si trasmette nella banda EU686 (default)
  if (!modem.begin(EU868)) {
    Serial.println("Il modulo LoRa non si è correttamente inizializzato!"); //se fallisce l'inizializzazione
    while (1) {}
  };
  Serial.print("Versione del modulo LoRa: ");
  Serial.println(modem.version());
  Serial.print("EUI dell'end-node Arduino MKR1300: ");
  Serial.println(modem.deviceEUI());
  
  int connected =modem.joinABP(devAddr, nwkSKey, appSKey); //si connette in modalità ABP
  if (!connected) {
    Serial.println("Non è riuscita la connessione; verificare la copertura radio");
    while (1) {}
  }

}
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void loop() {
  // lettura della tensione sul pin 2 (pin_input) dove è posto il pin dati del sensore LM35 

val_conv=analogRead(pin_input);

// conversione in temperatura della tensione rilevata
temp=(330.0/1023.0)*val_conv;

    //----------    conversione da float a caratteri ascii del dato di temperatura
    char buffer1[16];
    String str = String(temp, 2);
    str.toCharArray(buffer1,16);
    tempascii = buffer1;
    //-----------------------------------------------
    
Serial.print("Temperatura misurata dal sensore LM35:  ");
Serial.println(tempascii);
 
  int err;
  modem.setPort(3);
  modem.beginPacket();
  modem.print("Temperatura da Arduino MKR1300+LM35: ");
  delay(1000);
  modem.print(tempascii);
  err = modem.endPacket(true);
  //Serial.println(err);
  //delay(120*1000);
  //Serial.println(err);
  
  if (err > 0) {
    Serial.println("Messaggio inviato correttamente!");
  } else {
    Serial.println("Errore: messaggio non inviato:");
    Serial.println("Per le impostazioni del firmware di Arduino MKR1300 tra l'invio di un messaggio e l'altro");
    Serial.println("si può dover attendere 2-3 minuti!");
  }
delay(2.5*60*1000); //attendi 2.5 minuti prima di trasmettere nuovamente
  if (!modem.available()) {
    Serial.println("Nessun messaggio ricevuto in downlink");
    return;
  }
  char rcv[64];
  int i = 0;
  while (modem.available()) {
    rcv[i++] = (char)modem.read();
  }
  Serial.println("Messaggio ricevuto in downlink: ");
  for (unsigned int j = 0; j < i; j++) {
    Serial.print(rcv[j] >> 4, HEX);
    Serial.print(rcv[j] & 0xF, HEX);
    Serial.print(" ");
  }
  Serial.println();

}
