/* Sketch a corredo delle risorse online del libro di testo
   Onelio Bertazioli
   Telecomunicazioni - Seconda edizione
   Zanichelli*/

// misura di temperatura con Arduino MKR1300 LoRaWAN alimentato a batteria e sensore di temperatura e umidita' DHT11
//invio dei dati al network server loriot.io tramite il gateway Rasberry Pi
/* includere le librerie 
-> DHT Sensor Library: https://github.com/adafruit/DHT-sensor-library
-> Adafruit Unified Sensor Lib: https://github.com/adafruit/Adafruit_Sensor
 */
//collegare il pin dati del sensore al pin digitale 2; 
#include <DHT.h>
#include <DHT_U.h>

#define DHTTYPE    DHT11
#define DHTPIN 2   // Collega il pin segnale al pin 2 
//alimentare a 3,3 V!!!!!!

DHT dht(DHTPIN, DHTTYPE);

float temp; //temperatura
float umid; //umidità

char buffer[256];

#include <MKRWAN.h>

LoRaModem modem;

//-------------------------------------------------------------------------------
//inserire qui i vostri devAddr, nwkSKey, appSKey, fatti generare dal network server eu1.loriot.io
char * devAddr =  "ilvostro_devAddr";
char * nwkSKey = "la_vostra_nwkSKey";
char * appSKey = "la_vostra_appSKey";
//il devAddr e le chiavi sono ottenuti dal network server eui1.loriot.io al momento dell'attivazione nella modalità ABP (Activation By Personalization)
//-------------------------------------------------------------------------------

void setup() {
   modem.begin(EU868);
   delay(1000);     
   modem.dataRate(0);   // setta il data rate DR0 (250 bit/s) per massimizzare la distanza dal gateway
   delay(1000);  
   int connected =modem.joinABP(devAddr, nwkSKey, appSKey);
  
}

void loop() {
   umid = dht.readHumidity(); //legge l'umidità; ci vogliono circa 250 ms per leggere l'umidità o la temperatura
    delay(300);
  //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++
       
   temp = dht.readTemperature(); // legge la temperatura
  
  //+++++++++++++++  conversione da float a caratteri ascii dei dati acquisiti messi in una stringa
    char buffer1[16];
    String str = String(umid, 2);
    String str1 = String(temp, 2);
    String str2 = str+str1;    
    str2.toCharArray(buffer1,16);
    char* dati = buffer1;
 /* //++++++++++++++++++++++++++++++++++++++++++++++++++++++++  
    SerialUSB.println("-----------------------------------------");
    SerialUSB.print("Valori di temperatura e umidità inviati al server:  ");
    SerialUSB.println(dati);
    SerialUSB.println("-----------------------------------------");
    //-----------------------------------------------*/
    bool esito = false;
    //dopo aver trasmesso l'end device attende la risposta del gateway 
    
  int err;
  modem.setPort(3);
  modem.beginPacket();
  modem.print(dati); //invio dati di temperatura e umidita' rilevati
  err = modem.endPacket(true);
  delay(2.5*60*1000); //attendi 2.5 minuti; invia un dato di temperatura ogni 2.5 minuti
    
}
