/* Sketch a corredo delle risorse online del libro di testo
   Onelio Bertazioli
   Telecomunicazioni - Seconda edizione
   Zanichelli*/

// misura di temperatura con Arduino MKR1300 LoRaWAN alimentato a batteria e sensore LM35
//invio dei dati al network server loriot.io tramite il gateway Rasberry Pi
//----------------------------------------
#define pin_input A2  //denominiamo pin_input il pin A2 (opzionale)
int val_conv=0; //numero restituito dal convertitore A/D 
float temp; //temperatura
//---------------------------------------

#include <MKRWAN.h>
//incledere la libreria MKRWAN gestisce la comunicazione via LoRaWAN per Arduino MKR1300

LoRaModem modem;
//-------------------------------------------------------------------------------
//inserire qui i vostri devAddr, nwkSKey, appSKey, fatti generare dal network server eu1.loriot.io
char * devAddr =  "ilvostro_devAddr";
char * nwkSKey = "la_vostra_nwkSKey";
char * appSKey = "la_vostra_appSKey";
//il devAddr e le chiavi sono ottenuti dal network server eui1.loriot.io al momento dell'attivazione nella modalità ABP (Activation By Personalization)
//-------------------------------------------------------------------------------

char * tempascii;
//-------------------------------------------------------------------------------
void setup() {
   modem.begin(EU868);
   delay(1000);     
   modem.dataRate(0);   // setta il data rate DR0 (250 bit/s) per massimizzare la distanza dal gateway
   delay(1000);  
   int connected =modem.joinABP(devAddr, nwkSKey, appSKey);
  
}
//---------------------------------------------------------------------------------
void loop() {
  // lettura tensione in ingresso
val_conv=analogRead(pin_input);

temp=(330.0/1023.0)*val_conv; //conversione della tensione in temperatura (fondoscala 3.3 V)

    //----------    conversione da float a caratteri ascii
    char buffer1[16];
    String str = String(temp, 2);
    str.toCharArray(buffer1,16);
    tempascii = buffer1;
    
    //-----------------------------------------------
    
  int err;
  modem.setPort(3);
  modem.beginPacket();
  modem.print("Temperatura da Arduino MKR1300 con LM35: "); //invio testo di commnento
  delay(1000);
  modem.print(tempascii); //invio dato di temperatura rilevato
  err = modem.endPacket(true);
  delay(2.5*60*1000); //attendi 2.5 minuti; invia un dato di temperatura ogni 2.5 minuti
    
}
