/* Sketch a corredo delle risorse online del libro di testo
   Onelio Bertazioli
   Telecomunicazioni - Seconda edizione
   Zanichelli*/

//LORAWAN - MISURA DI TEMPERATURA ED UMIDITA' ARIA CON DHT 11 + TEMPERATURA ACQUA CON LM35 + LUMINOSITA' CON LED ROSSO + ALTEZZA ACQUA CON HC-SR04
/* includere le librerie 
-> DHT Sensor Library: https://github.com/adafruit/DHT-sensor-library
-> Adafruit Unified Sensor Lib: https://github.com/adafruit/Adafruit_Sensor
 */
//collegare il pin dati del sensore al pin digitale 2; 
//NB: collegare +VCC a 3.3 V per seeeduino!!
 
#include <DHT.h>
#include <DHT_U.h>

#define DHTTYPE    DHT11
#define DHTPIN 2   // Collega il pin segnale al pin 2 
//alimentare a 3,3 V!!!!!!

DHT dht(DHTPIN, DHTTYPE);

#include <LoRaWanmd.h>  
//libreria LoRaWan modificata per seeeduino anche alimentato a batteria (in questo caso eliminare dallo sketch tutte le righe che inviano dati al monitor)

float temp; //temperatura
float umid; //umidità

float TempLM35;  //variabile analogica temperatura piedino A2
float tempLM35;  //variabile temperatura convertita

float LuceLED;   //variabile analogica luminosità sul piedino A1
float LuxLED;    //variabile luminosità mappata 

float Terreno;    //variabile analogica sonda terreno sul piedino A0
float HumTerreno; //variabile umidità terreno adattata

const int TRIG_PIN = 12; //piedino TRIG ULTRASIONI
const int ECHO_PIN = 13;  //piedino ECHO ULTRASIONI

int durata_ULTRA;
int distanza_ULTRA;
float altezza_ACQUA;  //altezza acqua

char * altezza_ACQUAascii;  //altezza acqua ascii

                      char * distanza_ULTRAascii; 
/*char * tempascii;
 * 
char * umidascii;
*/
//char buffer[256];

//----------------------------------------
void setup(void)
{

    dht.begin();  // Inizializza il sensore

      
    lora.init();

    lora.setKey("lavostraNWKKEY", "lavostraAPPSKEY", NULL);
    //Chiavi NWKKEY, APPSKEY, APPKEY (NON usata per APB) da configurare sia su seeduino sia su loriot.io per configurare una sessione ABP (Activate By Personalization) su loriot.io)
    
    lora.setDeciveMode(LWABP);//setta la modalità ABP (Activation By Personalization) che fa unire direttamene un end-devicea una rete lorawan saltando la fase di JOIN della modalità OTAA
    
    lora.setDataRate(DR0,EU868 ); //setta il data rate DR0 (250 bit/s)
    
    lora.setChannel(0, 868.1);//setta i canali: ch0 f=868.1, ecc. i primi 3 sono quelli di default 
    lora.setChannel(1, 868.3);
    lora.setChannel(2, 868.5);
    /*Dopo aver trasmesso in uplink un frame un end device (o Mote) deve attendere la ricezione di una risposta;
     * a tale scopo sono definiti due intervalli di tempo (timeslot) detti finestre di ricezione entro cui l'end node deve attendere 
     * la ricezione di messaggi in downlink
     */
    lora.setReceiceWindowFirst(0, 868.1);
    lora.setReceiceWindowSecond(869.5, DR3);
    
    lora.setDutyCycle(false); //il duty cycle va fissato per la modalità OTAA e specifica l'intervallo di tempo rispetto a quello totale disponibile 
                              //in cui una risorsa è disponibile, cioè si trasmette 
    lora.setJoinDutyCycle(false);
    
    lora.setPower(14);//setta l'EIRP di trasmissione, il cui valore massimo è 14 dBm

    pinMode(TRIG_PIN,OUTPUT); //definisco stato TRIG ultrasuoni
    pinMode(ECHO_PIN,INPUT); //definisco stato ECHO ultrasuoni
}

void loop()
{   
        
  delay(115*100); // Attendi circa 20 secondi fra le misure

  umid = dht.readHumidity(); //legge l'umidità; ci vogliono circa 250 ms per leggere l'umidità o la temperatura
    delay(300);
  //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   temp = dht.readTemperature(); // legge la temperatura
   
  //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   TempLM35 = analogRead(A2); //rileva valore temperatura analogica su piedino A2
   tempLM35 = (((3.0/1024)*TempLM35)/0.01);  //calcolo temperatura con valore 3.0 V di tensione REF
   
 //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   LuceLED = analogRead(A1); //rileva valore luminosità analogica del led rosso su piedino A1
   LuxLED = map(LuceLED,0,100,0,200)*5;  //mappatura valore luminosità per conversione in LUX

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  Terreno=analogRead(A0);
  HumTerreno=(Terreno*100/180);

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++
    digitalWrite(TRIG_PIN, LOW);
    delayMicroseconds(2);
    digitalWrite(TRIG_PIN, HIGH);
    delayMicroseconds(10);
    digitalWrite(TRIG_PIN, LOW);
    durata_ULTRA = pulseIn(ECHO_PIN,HIGH);
    distanza_ULTRA = durata_ULTRA / 29.1 / 2 ; //converto tempo in distanza acqua-sensore
    altezza_ACQUA=200-distanza_ULTRA;  //calcolo altezza acqua
  
  //+++++++++++++++  conversione da float a caratteri ascii dei dati acquisiti messi in una stringa
    char buffer1[32];
    String str = String(umid, 2);
    String str1 = String(temp, 2);
    String str3 = String(tempLM35);
    String str4 = String(LuxLED);
    String str5 = String(HumTerreno);
    String str6 = String(altezza_ACQUA);
    
    String str2 = str+str1+str3+str4+str5+str6;  
      
    str2.toCharArray(buffer1,32);
    char* dati = buffer1;
 
    //dopo aver trasmesso l'end device attende la risposta del gateway 
    bool esito = false;
    esito = lora.transferPacket(dati);
    delay(10);
 
 }
