/* Sketch a corredo delle risorse online del libro di testo
   Onelio Bertazioli
   Telecomunicazioni - Seconda edizione
   Zanichelli*/
// MISURA DI TEMPERATURA ED UMIDITA' CON IL SENSORE DHT 11
/* includere le librerie 
-> DHT Sensor Library: https://github.com/adafruit/DHT-sensor-library
-> Adafruit Unified Sensor Lib: https://github.com/adafruit/Adafruit_Sensor
 */
//collegare il pin dati del sensore al pin digitale 2; 
//NB: collegare +VCC a 3.3 V per seeeduino!!

#include <DHT.h>
#include <DHT_U.h>

#define DHTTYPE    DHT11
#define DHTPIN 2   // Collega il pin segnale al pin 2 
//alimentare a 3,3 V!!!!!!

DHT dht(DHTPIN, DHTTYPE);

#include <LoRaWanmd.h>  //libreria LoRaWan modificata per alimentazione a batteria di Seeeduino

float temp; //temperatura
float umid; //umidità

//----------------------------------------
void setup(void)
{

    dht.begin();  // Inizializza il sensore

    lora.init();
          
    lora.setKey("lavostraNWKKEY", "lavostraAPPSKEY", NULL);
    //Chiavi NWKKEY, APPSKEY, APPKEY (NON usata per APB) da configurare sia su seeduino sia su loriot.io per configurare una sessione ABP (Activate By Personalization) su loriot.io)
    
    lora.setDeciveMode(LWABP);//setta la modalità ABP (Activation By Personalization) che fa unire direttamene un end-devicea una rete lorawan saltando la fase di JOIN della modalità OTAA
    
    lora.setDataRate(DR0, EU868); //setta il data rate DR0 (250 bit/s)
    
    lora.setChannel(0, 868.1);//setta i canali: ch0 f=868.1, ecc. i primi 3 sono quelli di default 
    lora.setChannel(1, 868.3);
    lora.setChannel(2, 868.5);
    /*Dopo aver trasmesso in uplink un frame un end device (o Mote) deve attendere la ricezione di una risposta;
     * a tale scopo sono definiti due intervalli di tempo (timeslot) detti finestre di ricezione entro cui l'end node deve attendere 
     * la ricezione di messaggi in downlink
     */
    lora.setReceiceWindowFirst(0, 868.1);
    lora.setReceiceWindowSecond(869.5, DR3);
    
    lora.setDutyCycle(false); //il duty cycle va fissato per la modalità OTAA e specifica l'intervallo di tempo rispetto a quello totale disponibile 
                              //in cui una risorsa è disponibile, cioè si trasmette 
    lora.setJoinDutyCycle(false);
    
    lora.setPower(14);//setta l'EIRP di trasmissione, il cui valore massimo è 14 dBm
}

void loop()
{   
        
  delay(30*1000); // Attendi 60s fra due misure

  umid = dht.readHumidity(); //legge l'umidità; ci vogliono circa 250 ms per leggere l'umidità o la temperatura
    delay(300);
  //+++++++++++++++++++++++++++++++++++++++++++++++++++++++++
       
   temp = dht.readTemperature(); // legge la temperatura
  
  //+++++++++++++++  conversione da float a caratteri ascii dei dati acquisiti messi in una stringa
    char buffer[16];
    String str = String(umid, 2);
    String str1 = String(temp, 2);
    String str2 = str+str1;    
    str2.toCharArray(buffer,16);
    char* dati = buffer;
    bool esito = false;
    //dopo aver trasmesso l'end device attende la risposta del gateway 
    esito = lora.transferPacket(dati);
    delay(10);
  
   
}
