/*
  Misura di umidità e temperatura con un sensore DHT22 e visualizzazione sull'applicazione 
  Android “Bluetooth Electronics”, pannello "Temperature and Humidity Demo".

  Librerie per il sensore DHT22:
-> DHT Sensor Library: https://github.com/adafruit/DHT-sensor-library
-> Adafruit Unified Sensor Lib: https://github.com/adafruit/Adafruit_Sensor 
*/

#include <DHT.h>
# include <DHT_U.h>

#include <SoftwareSerial.h>    
SoftwareSerial SerialBlue (2, 4); // comunicazione verso il modulo HC-XX 
                                  // pin di Arduino: 2=RX ; 4=TX
int dataPin = 9;
DHT dht(dataPin, DHT22);          // inizializza il sensore DHT22

unsigned int temp;                // temperatura in °C
unsigned int humidity;            // umidità relativa (%RH) 


void setup() {

  SerialBlue.begin(9600);         // inizializza comunicazione via Bluetooth
  Serial.begin(9600);             // inizializza Serial Monitor
  dht.begin();                    // inizializza comunicazione con il DHT22
}

void loop() {
  
  delay (2000);   // pausa di 2 s prima di una nuova richiesta di misura
 
  humidity = dht.readHumidity();  // leggi l'umidità dal DHT22
  temp= dht.readTemperature();    // leggi la temperatura dal DHT22
 
          // trasmetti umidità e temperatura su Bluetooth in formato ‘*Txx*’ e ‘*Hxx*’
  SerialBlue.print ("*T"+String(temp)+"*");       // trasmetti temperatura
  SerialBlue.print ("*H"+String(humidity)+"*");   // trasmetti umidità

          // scrivi umidità e temperatura su Serial Monitor  

  Serial.print("Umidità: ");
  Serial.print(humidity);
  Serial.print(" %, Temp: ");
  Serial.print(temp);
  Serial.println(" °C");
}

